%define major	7
%define lib_name_orig lib%{name}
%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d

Summary:	Library for reading lines from a terminal
Name:		readline
Version:	7.0
Release:	%mkrel 3
License:	GPLv3
Group:		System/Libraries
Url:		http://tiswww.case.edu/php/chet/readline/rltop.html
Source0:	ftp://ftp.gnu.org/gnu/readline/%{name}-%{version}.tar.xz
Patch0:		readline-4.3-no_rpath.patch
Patch1:		readline-4.1-outdated.patch
Patch2:		rl-header.patch
Patch3:		rl-attribute.patch
Patch4:		readline-6.3-fix-shared-libs-perms.patch
Patch23:	readline-7.0-gdb.patch
Patch33:	ftp://ftp.gnu.org/gnu/readline/readline-7.0-patches/readline70-001
Patch34:	ftp://ftp.gnu.org/gnu/readline/readline-7.0-patches/readline70-002
Patch35:	ftp://ftp.gnu.org/gnu/readline/readline-7.0-patches/readline70-003
Patch36:	ftp://ftp.gnu.org/gnu/readline/readline-7.0-patches/readline70-004
Patch37:	ftp://ftp.gnu.org/gnu/readline/readline-7.0-patches/readline70-005

BuildRequires:	pkgconfig(ncursesw)

%description
The "readline" library will read a line from the terminal and return it,
allowing the user to edit the line with the standard emacs editing keys.
It allows the programmer to give the user an easier-to-use and more
intuitive interface.

%package -n %{libname}
Summary:	Shared libraries for readline
Group:		System/Libraries
Requires(pre):	filesystem 
Provides:	%{name} = %{version}-%{release}
Obsoletes:	%{name}

%description -n	%{libname}
This package contains the library needed to run programs dynamically
linked to readline.

%package doc
Summary:	Readline documentation in GNU info format
Group:		Documentation
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-doc = %{version}-%{release}
Obsoletes:	%{libname}-doc

%description doc
This package contains readline documentation in the GNU info format.

%package -n %{develname}
Summary:	Files for developing programs that use the readline library
Group:		Development/Libraries
Requires(pre):	filesystem
Requires:	ncursesw-devel
Requires:	%{libname} = %{version}-%{release}
Provides:	%{lib_name_orig}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{mklibname readline 5 -d}
Obsoletes:	%{name}-devel < %{version}

%description -n	%{develname}
The "readline" library will read a line from the terminal and return it,
using prompt as a prompt.  If prompt is null, no prompt is issued.  The
line returned is allocated with malloc(3), so the caller must free it when
finished.  The line returned has the final newline removed, so only the
text of the line remains.

%prep
%setup -q
%patch0 -p1 -b .no_rpath
%patch1 -p1 -b .outdated
%patch2 -p1 -b .header
%patch3 -p1 -b .attribute
%patch4 -p1 -b .fix-perms
%patch23 -p1 -b .gdb
%patch33 -p0
%patch34 -p0
%patch35 -p0

# Fix upstream perm Bug #3053
chmod 644 examples/rlfe/ChangeLog

libtoolize --copy --force

%build

export LDFLAGS="-I%{_includedir}/ncursesw -lncursesw"

%configure2_5x \
	 --with-curses \
	 --enable-multibyte

perl -p -i -e 's|-Wl,-rpath.*||' shlib/Makefile

%make

%install
rm -rf %buildroot
%makeinstall_std

perl -p -i -e 's|/usr/local/bin/perl|/usr/bin/perl|' doc/texi2html

rm -f %{buildroot}%{_defaultdocdir}/%{name}/*

mkdir %buildroot/%{_lib}
mv %buildroot%{_libdir}/libreadline.so.* %buildroot/%{_lib}
for l in %buildroot%{_libdir}/libreadline.so; do
    ln -sf $(echo %{_libdir} | \
        sed 's,\(^/\|\)[^/][^/]*,..,g')/%{_lib}/$(readlink $l) $l
done

mv %buildroot%{_libdir}/libhistory.so.* %buildroot/%{_lib}
for l in %buildroot%{_libdir}/libhistory.so; do
    ln -sf $(echo %{_libdir} | \
        sed 's,\(^/\|\)[^/][^/]*,..,g')/%{_lib}/$(readlink $l) $l
done


%post doc
%{_install_info history.info}
%{_install_info readline.info}

%preun doc
%{_remove_install_info history.info}
%{_remove_install_info readline.info}

%files -n %{libname}
/%{_lib}/lib*.so.%{major}*

%files doc
%{_infodir}/*info*

%files -n %{develname}
%doc CHANGELOG CHANGES MANIFEST README USAGE
%doc doc examples support
%{_mandir}/man3/*
%{_datadir}/readline
%{_includedir}/readline
%{_libdir}/lib*.a
%{_libdir}/lib*.so


%changelog
* Sun Sep 15 2019 tex - 7.0-3pclos2019
- rebuild against updates

* Tue Nov 14 2017 bb2 <bb2> - 7.0-2pclos2017
- move library files

* Sun Nov 05 2017 bb2 <bb2> - 7.0-1pclos2017
- new version
